
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x,y,y1,i,j,ct,p;
let v;
let u;
let dv;
let av;
let f,f1,f2,f3,f4,f5;
let r,l,m,r1,r2,r3;
let a,b,c,e,a1,a2,a3,h1,h2;
let d = { width: canvas.width, height: canvas.height };

function init() {
	f=0;f1=1;f2=0;f3=1;f4=2;
		v=0;u=2;
		av=2;	
		dv=av;
		r=12;
		r1=12;r3=12;//4
		r2=12;//6
		l=240;
		m=3;
		a3=60;
		a1=60;a2=120;//amplitude
		b=420;//ref. place  420
		c=50;//string place
		h1=190;
		h2=380;
		e=-1;	
		buffer = createBuffer(d.width, d.height);
        drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
	const g = buffer.getContext("2d");
	    g.fillStyle = "white";
		g.fillRect(0,30,d.width,d.height);
		g.strokeStyle = "lightGray";
        g.beginPath();
        g.moveTo(0,h1);
        g.lineTo(b+r1/2,h1);
        g.stroke();
		g.strokeStyle = "black";
        g.beginPath();
        g.moveTo(b+r1/2,30);
        g.lineTo(b+r1/2,d.height);
        g.stroke();
		if(f1==0){
        g.fillStyle = "blue";
		g.fillText("pulseWave",40,c+3);
		}
		if(f1==1){
        g.fillStyle = "blue";
		g.fillText("sineWave",40,c+3);
		}
		if(f2==0){
        g.fillStyle = "blue";
		g.fillText("freeEnd",b-40,c+3);
		}
		if(f2==4){
        g.fillStyle = "blue";
		g.fillText("fixedEnd",b-40,c+3);
		}
		if(f3==1){
		g.strokeStyle = "blue";
        g.beginPath();
        g.moveTo(600,c);
        g.lineTo(630,c);
        g.stroke();
        g.fillStyle = "blue";
		g.fillText("SuperposedWave",640,c+3);
				}
		if(f3==0){
        g.strokeStyle = "blue";
        g.beginPath();
        g.moveTo(600,c);
        g.lineTo(630,c);
        g.stroke();
		g.fillStyle = "blue";
		g.fillText("SuperposedWave",640,c+3);//695
		g.strokeStyle = "cyan";
        g.beginPath();
        g.moveTo(600,c+15);
        g.lineTo(630,c+15);
        g.stroke();
		g.fillStyle = "cyan";
		g.fillText("IncidentWave",640,c+15+3);
		g.strokeStyle = "magenta";
        g.beginPath();
        g.moveTo(600,c+30);
        g.lineTo(630,c+30);
        g.stroke();
		g.fillStyle = "magenta";
		g.fillText("ReflectedWave",640,c+30+3);
			}
       
	   /* g.fillStyle = "black";
		g.fillText("speed",270,d.height-c);
		g.fillStyle = "blue";
		if(av==1)g.fillText("Low",230,d.height-c);
		if(av==2)g.fillText("Medium",210,d.height-c);
		if(av==4)g.fillText("High",230,d.height-c);*/
        
		if(f4==0){
		    g.fillStyle = "red";
			g.fillText("program Running",570,d.height-c);
			}	
		if(f4==1){
	        g.fillStyle = "red";
			g.fillText("program Stop",570,d.height-c);
				}	
		if(f4==2){
		    g.fillStyle = "blue";
			g.fillText("program Reset",570,d.height-c);
				}
		if(f4==3){
		    g.fillStyle = "red";
			g.fillText("stepBystep",570,d.height-c);
				}
			
		if(f1==1){       //   sineWave   
		 for (x=Math.floor(v/r1)*r1+r1;x<=b;x=x+r1){       //incidence 横波
			y=h1;		
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		    g.fillStyle = "blue";
		    g.fillRect(x+r1/3,h2,r1/3,4*r1);//縦波
		}
		if(v<=b){
		for (x=0;x<=v;x=x+r1){//0-r1
			y=(a1*Math.sin((x-v)*3.1415*2/l)+h1);		
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			y=(-20*Math.sin((x-v)*3.1415*2/l))+x+r1/3;
		    g.fillStyle = "blue";
		    g.fillRect(y,h2,r1/3,4*r1);//縦波
			}
		}
		
		if(f3==0){//構成波
		if(v>b){
		for (x=b;x>=0;x=x-r1){//b,0,-
			y=(a1*Math.sin((x-v)*3.1415*2/l))+h1;		
	        g.fillStyle = "cyan";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
				}
		if(f5==1&&v<=2*b){
		for (x=b;x<=v;x=x+r1){//b,0,-   壁右
			y=(a1*Math.sin((x-v)*3.1415*2/l))+h1;
			g.fillStyle = "cyan";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		}
			if(v>2*b){
		if(f5==1){
		for (x=b;x<=d.width;x=x+r1){//b,0,-   壁右
			y=(a1*Math.sin((x-v)*3.1415*2/l))+h1;
			g.fillStyle = "cyan";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();	
	    	}
		}
		}
        }
	}
	     if(v>b&&v<=2*b){                 //inci
			for (x=-2*r1;x<=2*b-v;x=x+r1){//0----2*r1
			y=(a1*Math.sin((x-v)*3.1415*2/l))+h1;
			g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);//////
			g.fill();
			y=(-20*Math.sin((x-v)*3.1415*2/l))+x+r1/3;
			g.fillStyle = "blue";
		    g.fillRect(y,h2,r1/3,4*r1);//縦波
	
		}
        }

        if(f3==0&&f2!=2){//  構成波
	  if(v>=b&&v<=2*b){                 //refrection
			for (x=b;x>=2*b-v;x=x-r1){
			y=(a3*Math.sin((2*b-x-v)*3.1415*2/l))+(h1);
		    g.fillStyle = "magenta";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
		if(f5==1){
		for (x=b+r1;x<=v;x=x+r1){    //壁右
			y=(a3*Math.sin((-v+x+2)*3.1415*2/l))+(h1);
		    g.fillStyle = "magenta";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		}
        }
        if(2*b<=v){                 //refrection
			for (x=b;x>=0;x=x-r1){
			y=(a3*Math.sin((2*b-x-v)*3.1415*2/l))+(h1);
		    g.fillStyle = "magenta";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
		if(f5==1){
		for (x=b+r1;x<=d.width;x=x+r1){    //壁右
			y=(a3*Math.sin((-v+x+2)*3.1415*2/l))+(h1);
		    g.fillStyle = "magenta";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
		}
        }
   }
        if(f2!=2){
       if(v>=b&&v<=2*b){                 //all
			for (x=b;x>=2*b-v;x=x-r1){
			y=(a3*Math.sin((2*b-x-v)*3.1415*2/l))+(h1)
				+(a1*Math.sin((x-v)*3.1415*2/l));
		    g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			y=((-a3/3)*Math.sin((2*b-x-v)*3.1415*2/l))+x
				+(-20*Math.sin((x-v)*3.1415*2/l))+r1/3;//////////+r1/3
			 g.fillStyle = "blue";	
		     g.fillRect(y,h2,r1/3,4*r1);//縦波
			}
        }
		if(2*b<v){                 //all
			for (x=b;x>=-2*r1;x=x-r1){//0-----2*r1
			y=(a3*Math.sin((2*b-x-v)*3.1415*2/l))+(h1)
				+(a1*Math.sin((x-v)*3.1415*2/l));
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		    y=((-a3/3)*Math.sin((2*b-x-v)*3.1415*2/l))+x+r1/3
				+((-a1/3)*Math.sin((x-v)*3.1415*2/l));
		    g.fillStyle = "blue";
		    g.fillRect(y,h2,r1/3,4*r1);//縦波
			}
        }
	}
	 }       //  sineWave end
	 
	 
	 
	
		 if(f1==0){       //   pulse  
		 for (x=Math.floor(v/r1)*r1+r1;x<=b;x=x+r1){       //incidence
		      y=h1;		//frontofthepulse
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
	        g.fillStyle = "blue";
		    g.fillRect(x+r1/3,h2,r1/3,4*r1);//縦波
		}
		if(v<=b){
		for (x=0-2*r1;x<Math.floor((v-l)/r1)*r1;x=x+r1){        //behind the pulse
		y=h1;		
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		    g.fillStyle = "blue";
		    g.fillRect(x+r1/3,h2,r1/3,4*r1);//縦波
		}
		for (x=0-2*r1;x<=v;x=x+r1){         //pulse
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+h1;		
	        if(x<=v-l)y=h1;
			g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		y=-((-a1/2)*(1-Math.cos((x-v)*3.1415*2/l))/2)+x+r1/3;
		if(x<=v-l)y=x+r1/3;	
		    g.fillStyle = "blue";
		g.fillRect(y,h2,r1/3,4*r1);//縦波
		}	
        }
		
		if(f3==0){//構成波　　入射波
		
		if(v>b){//&&v<=2*b
		for (x=0;x<=b;x=x+r1){
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+h1;		
	        if(x<=v-l)y=h1;
			g.fillStyle = "cyan";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		if(f5==1){//参考波　　　壁右
		for (x=b;x<=v;x=x+r1){
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+h1;		
	        if(x<=v-l)y=h1;
			g.fillStyle = "cyan";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		}
        }
	}
	      if(v>b){                 //inci   &&v<=2*b
			for (x=0-2*r1;x<=2*b-v;x=x+r1){
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+h1;
			if(x<=v-l)y=h1;
			g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		
			y=-((-a1/2)*(1-Math.cos((x-v)*3.1415*2/l))/2)+x+r1/3;//縦波
			if(x<=v-l)y=x+r1/3;
			g.fillStyle = "blue";
		g.fillRect(y,h2,r1/3,4*r1);//縦波
				}
        }
		if(f5==1&&f3==0&&v>=b){  // 参考波
			for (x=b+r1;x<=v;x=x+r1){       //pulse
			y=-(a3*(1-Math.cos((x-v)*3.1415*2/l))/2)+(h1);
		         if(x<=v-l)y=h1;
				 g.fillStyle = "magenta";
		         g.beginPath();
		         g.arc(x+2+r1/2,y,r1/2, 0, Math.PI * 2);
			     g.fill();
				}			
		}
		if(f3==0){//構成波
	  if(v>=b&&v<=2*b+l){     //+l            //refrection
			for (x=b;x>=2*b-v;x=x-r1){       //pulse
			y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(h1);
		        if(x>=2*b-v+l&&x<=b)y=(h1);//behind the pulse
				g.fillStyle = "magenta";
		         g.beginPath();
		         g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			     g.fill();
		
		}
	
        }
        if(2*b+l<=v){                 //refrection
			for (x=b;x>=0;x=x-r1){
				y=(h1);
				g.fillStyle = "magenta";
		         g.beginPath();
		         g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			     g.fill();
		}
        }
   }//
   if(f2!=2){
       if(v>=b&&v<=2*b+l){                 //all
		
            if(2*b-v>v-l){
					for (x=b;x>=2*b-v;x=x-r1){
	         	y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(h1)
				-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2);
				   g.fillStyle = "blue";
		         g.beginPath();
		         g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			     g.fill();
				y=-((-a3/2)*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+x+r1/3
				-((-a1/2)*(1-Math.cos((x-v)*3.1415*2/l))/2);
				g.fillStyle = "blue";
				g.fillRect(y,h2,r1/3,4*r1);//縦波
					}
			        }
			if((2*b-v<=v-l)&&(b>=v-l)){
			

                    	for (x=b;x>=2*b-v;x=x-r1){
							if(x<=v-l)
	         	y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(h1);
						if(x>v-l)
	         	y=-(d.height/2);//exclusive
				          g.fillStyle = "blue";
		                  g.beginPath();
		                   g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			                g.fill()
						
						if(x<=v-l)
	         	y=-((-a3/2)*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+x+r1/3;
						if(x>v-l)
	         	y=-(x+r1/3);//exclusive//-
				g.fillStyle = "blue";
				g.fillRect(y,h2,r1/3,4*r1);//縦波
			        }
        for (x=b;x>=v-l;x=x-r1){
				y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(h1)
				-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2);
	         			g.fillStyle = "blue";
		                  g.beginPath();
		                   g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			                g.fill()	
						
					y=-((-a3/2)*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+x+r1/3
				-((-a1/2)*(1-Math.cos((x-v)*3.1415*2/l))/2);
				g.fillStyle = "blue";
				g.fillRect(y,h2,r1/3,4*r1);//縦波
			        }
				}
			if(2*b-v+l<b){
			for (x=b;x>=2*b-v;x=x-r1){       //pulse
			y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(h1);
		        if(x>=2*b-v+l&&x<=b)y=(h1);//behind the pulse
				g.fillStyle = "blue";
		                  g.beginPath();
		                   g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			                g.fill()
			y=-((-a3/2)*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+x+r1/3;
		        if(x>=2*b-v+l&&x<=b)y=x+r1/3;//behind the pulse
				g.fillStyle = "blue";
			g.fillRect(y,h2,r1/3,4*r1);//縦波
		
		}
        }
		}
        if(2*b+l<=v){                 //refrection
			for (x=b;x>=0;x=x-r1){
	
		y=(h1);
		g.fillStyle = "blue";
	    g.beginPath();
		g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
	    g.fill()
		g.fillStyle = "blue";
		g.fillRect(x+r1/3,h2,r1/3,4*r1);//縦波		
		}
        }

	}//
    }       //  pulse end 
}
		
function move() {
	    dv=f*av;
		v=v+dv;
		ct=ct+f*1;
        
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
} 

document.getElementById('pulse').addEventListener('click', pulse);
document.getElementById('sin').addEventListener('click', sin);
document.getElementById('free').addEventListener('click', free);
document.getElementById('fix').addEventListener('click', fix);
document.getElementById('go').addEventListener('click', go);
document.getElementById('ko').addEventListener('click', ko);
document.getElementById('sa').addEventListener('click', sa);
document.getElementById('Step').addEventListener('click', Step);
document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Stop').addEventListener('click', Stop);
document.getElementById('Reset').addEventListener('click', Reset);


function pulse() {
       f1=0;
}
function sin() {
        f1=1;
}
function free() {
        f2=0;r1=12;a1=60;a3=a1;l=240;
			if(f1==0){a1=60;a2=0;a3=60;l=240;}
}
function fix() {
        f2=4;l=240;r1=12;r2=12;a3=-60;a2=0;u=0.1;
			 if(f1==0){a1=60;a2=0;a3=-60;l=240;}
}
function go() {
        f3=1;f5=0;
}
function ko() {
        f3=0;f5=0;
}
function sa() {
        f3=0;f5=1;
}
function Run() {
        f=1;f4=0;
}
function Stop() {
        f=0;dv=0;f4=1;
}
function Step() {
        f=0;v=v+2;ct=ct+1;f4=3;
}
function Reset() {
        f=0;v=0;dv=0;y=0;f4=2;ct=0;
}

init();
start();




